<?

/*
 * (c) 2004-2007 Linbox / Free&ALter Soft, http://linbox.com
 * (c) 2007 Mandriva, http://www.mandriva.com
 *
 * $Id: launch_bundle.php 3719 2009-02-19 08:05:34Z cdelfosse $
 *
 * This file is part of Mandriva Management Console (MMC).
 *
 * MMC is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * MMC is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with MMC; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 */

require_once('modules/msc/includes/widgets.inc.php');
require_once('modules/msc/includes/utilities.php');
require_once('modules/msc/includes/qactions.inc.php');
require_once('modules/msc/includes/mirror_api.php');
require_once('modules/msc/includes/commands_xmlrpc.inc.php');
require_once('modules/msc/includes/package_api.php');
require_once('modules/msc/includes/scheduler_xmlrpc.php');
require_once('modules/msc/includes/mscoptions_xmlrpc.php');
require_once('modules/msc/includes/apt_roll_widgets.php');

/*require("modules/msc/includes/functions.php");
require("modules/msc/includes/machines.inc.php");
require("modules/msc/includes/command_history.php");
require("modules/msc/includes/scheduler_xmlrpc.php");
*/








function launch_bundle($cible, $orders, $gid = null, $proxy = array()) {
    $params = array();
    foreach (array('start_date', 'end_date', 'create_directory', 'start_script', 'delete_file_after_execute_successful', 'wake_on_lan', 'next_connection_delay', 'max_connection_attempt', 'start_inventory', 'maxbw', 'deployment_intervals', 'copy_mode', 'clean_on_success', 'do_wol', 'do_inventory', 'do_reboot', 'bundle_title') as $param) {
        $params[$param] = $_POST[$param];
    }
    $halt_to = array();
    foreach ($_POST as $p=>$v) {
        if (preg_match('/^issue_halt_to_/', $p)) {
            $p = preg_replace('/^issue_halt_to_/', '', $p);
            $halt_to[] = $p;
        }
    }
    $params['issue_halt_to'] = $halt_to;

    // given a proxy list and a proxy style, we now have to build or proxy chain
    // target structure is an dict using the following stucture: "priority" => array(proxies)

    $ordered_proxies = array();
    if ($_POST['proxy_mode'] == 'multiple') { // first case: split mode; every proxy got the same priority (1 in our case)
        foreach ($proxy as $p) {
            array_push($ordered_proxies, array('uuid' => $p, 'priority' => 1, 'max_clients' => $_POST['max_clients_per_proxy']));
        }
        $params['proxy_mode'] = 'split';
    } elseif ($_POST['proxy_mode'] == 'single') { // second case: queue mode; one priority level per proxy, starting at 1
        $current_priority = 1;
        foreach ($proxy as $p) {
            array_push($ordered_proxies, array('uuid' => $p, 'priority' => $current_priority, 'max_clients' => $_POST['max_clients_per_proxy']));
            $current_priority += 1;
        }
        $params['proxy_mode'] = 'queue';
    }

    // TODO: activate this  : msc_command_set_pause($cmd_id);
    $ret = add_bundle_api($orders, $cible, $params, $params['copy_mode'], $gid, $ordered_proxies);
    if (is_array($ret) && !empty($ret)) {
        $commands = $ret[1];
        scheduler_start_these_commands('', $commands);
    }
    return $ret;
}




$list = new RenderedMSCAptChoiceM();
$list->display();



//$list = new RenderedMSCBundleChoiceG($group);
//$list->display();


?>
